import { Identity, MakeRequired, RSA, RSN } from "./utils";
import type { Validate } from "./validate";
export declare type Guard<Type, Options extends RSA = RSN> = Validate<Type> & ((options: Partial<Options>) => Validate<Type>);
export declare type GuardOptions<Name extends keyof vality.guards, G = vality.guards[Name]> = G extends Guard<infer Type, infer Options> ? [Type, Options] : G extends (...args: any[]) => Guard<infer Type, infer Options> ? [Type, Options] : never;
declare type ExtraOptions<T> = {
    transform?: Identity<T>;
    validate?: (val: T) => boolean;
};
export declare function guard<Name extends keyof vality.guards, Type extends GuardOptions<Name>[0], Options extends RSA & Omit<GuardOptions<Name>[1], keyof ExtraOptions<any>>>(name: Name, fn: (val: unknown, options: Partial<Options>) => Type | undefined, handleOptions?: {
    [K in keyof ({
        [K in keyof Options]?: (val: Type, o: NonNullable<Options[K]>, options?: MakeRequired<Options, K>) => boolean;
    } & {
        [K in keyof ExtraOptions<Type>]: ExtraOptions<Type>[K];
    })]: ({
        [K in keyof Options]?: (val: Type, o: NonNullable<Options[K]>, options?: MakeRequired<Options, K>) => boolean;
    } & {
        [K in keyof ExtraOptions<Type>]: ExtraOptions<Type>[K];
    })[K];
}, defaultOptions?: {
    [K in keyof Options]?: Options[K];
}): Guard<Type, Options>;
export {};
