import { ParseIn } from "./parse";
import { _type, _validate, _valit, _virtual } from "./symbols";
import { Eny } from "./utils";
export interface Error {
    message: string;
    path: Path;
    options: any;
    value: any;
}
export declare type Validate<T> = {
    [_validate]: ValidateFn<T>;
    [_type]: T;
    [_virtual]?: false;
    [_valit]?: false;
};
export declare type ValidateFn<T> = (val: unknown, path?: Path) => ValidationResult<T>;
export declare type ValidationResult<T> = {
    valid: true;
    data: T;
    errors: never[];
} | {
    valid: false;
    data: undefined;
    errors: Error[];
};
export declare type Path = (string | number)[];
export declare function validate<E extends Eny>(schema: E, val: unknown, bail?: boolean): ValidationResult<ParseIn<E>>;
